#### INPUTS
#comm : a species presence-absence matrix with assemblages as col names and species as row names.
#ellenberg : an Ellenberg values matrix with Ellenberg values as col names and species as row names.

#### OUTPUT
# a dataframe listing for each pair of assemblages the similarity of Ellenberg edaphic indicator values (SE)

#Verify whether row names (species) are the same between matrices
row.names(comm)==row.names(ellenberg)

#####Ellenberg indicator 1 : Moisture #####
#Transformation of comm matrix 

comm_Moisture<-comm*ellenberg$Moisture # replace the presence of a species (1) by its Ellenberg value
comm_Moisture<-replace(comm_Moisture, comm_Moisture==0, NA) #replace the absence of a species (0) by NA
moy_Moisture<-colMeans(comm_Moisture, na.rm=T) # mean Ellenberg values of species recorded in each assemblages
moyma_Moisture<-as.matrix(moy_Moisture)


EcEll_Moisture<-sapply(moy, function(x) abs(x-moy_Moisture)) #Compute the similarity of Ellenberg edaphic value between each pair of assemblages
EcEll_Moisture 
require(reshape)
Ec_Ellen_Moisture<-melt(EcEll_Moisture)
Ec_Ellen_Moisture=Ec_Ellen_Moisture[melt(upper.tri(EcEll_Moisture))$value,]
Ec_Ellen_Moisture

#####Ellenberg 2 : Nutrient #####
comm_Nutrient<-comm*ellenberg$Nutrient
comm_Nutrient=replace(comm_Nutrient, comm_Nutrient==0, NA) 
moy_Nutrient<-colMeans(comm_Nutrient, na.rm=T) 
moy_Nutrient
moyma_Nutrient<-as.matrix(moy_Nutrient)
nrow(moyma_Nutrient)

EcEll_Nutrient<-sapply(moy, function(x) abs(x-moy_Nutrient)) 
require(reshape)
Ec_Ellen_Nutrient<-melt(EcEll_Nutrient)
Ec_Ellen_Nutrient=Ec_Ellen_Nutrient[melt(upper.tri(EcEll_Nutrient))$value,]
Ec_Ellen_Nutrient


#####Ellenberg 3 : pH #####
comm_pH<-comm*ellenberg$pH
comm_pH #Matrice ou les 
comm_pH=replace(comm_pH, comm_pH==0, NA) 
moy_pH<-colMeans(comm_pH, na.rm=T) 
moy_pH
moyma_pH<-as.matrix(moy_pH)
nrow(moyma_pH)

EcEll_pH<-sapply(moy, function(x) abs(x-moy_pH)) 
EcEll_pH 
require(reshape)
Ec_Ellen_pH<-melt(EcEll_pH)
Ec_Ellen_pH=Ec_Ellen_pH[melt(upper.tri(EcEll_pH))$value,]
Ec_Ellen_pH

write.csv(Ec_Ellen_Moisture, "namefile.csv")
write.csv(Ec_Ellen_Nutrient, "namefile2.csv")
write.csv(Ec_Ellen_pH, "namefile3.csv")